using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.Services.Protocols;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Security.Cryptography.X509Certificates;

using Microsoft.Web.Services3;
using Microsoft.Web.Services3.Design;
using Microsoft.Web.Services3.Configuration;
using Microsoft.Web.Services3.Security;
using Microsoft.Web.Services3.Security.Tokens;
using Microsoft.Web.Services3.Security.X509;

public partial class _Default : System.Web.UI.Page
{
	SoapProtocolVersion _soapVersion = SoapProtocolVersion.Default;

	protected SoapProtocolVersion SoapVersion
	{
		get
		{
			return _soapVersion;
		}
	}

	public _Default()
	{
		string soapVersion = System.Configuration.ConfigurationManager.AppSettings["soapversion"];

		switch (soapVersion)
		{
			case "soap11":
				_soapVersion = SoapProtocolVersion.Soap11;
				break;
			case "soap12":
				_soapVersion = SoapProtocolVersion.Soap12;
				break;
			default:
			case "default":
				_soapVersion = SoapProtocolVersion.Default;
				break;
		}
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		WSEClientLib.Service.FibonacciWse service = new WSEClientLib.Service.FibonacciWse();
		service.Url = "http://webservices.dev.entfederal.com/FibWse/Fibonacci.asmx";
		ConfigureProxy(service);

		service.SetPolicy("ClientPolicy2");

		string[] fibNumbers = service.CalculateFibonacci(25);

		foreach (string fibNumber in fibNumbers)
		{
			if (!fibNumber.StartsWith("DATA"))
			{
				HtmlTableRow row = new HtmlTableRow();
				HtmlTableCell cell = new HtmlTableCell();
				cell.InnerText = fibNumber;

				row.Cells.Add(cell);
				Results.Rows.Add(row);
			}
		}
	}


	/// <summary>
	/// Looks for any configuration settings that may modify
	/// the Web service proxy used and modifies the proxy accordingly.
	/// </summary>
	protected void ConfigureProxy(SoapHttpClientProtocol protocol)
	{
		string remoteHost = ConfigurationManager.AppSettings["remoteHost"];
		if (remoteHost != null)
		{
			Uri remoteHostUri = new Uri(remoteHost);
			Uri protocolUrl = new Uri(protocol.Url);
			Uri newUri = new Uri(remoteHostUri, protocolUrl.AbsolutePath);

			if (protocol is Microsoft.Web.Services3.WebServicesClientProtocol)
			{
				((Microsoft.Web.Services3.WebServicesClientProtocol)protocol).Url = newUri.AbsoluteUri;
			}
			else
			{
				protocol.Url = newUri.AbsoluteUri;
			}
		}

		protocol.SoapVersion = SoapVersion;
	}
}
